unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DRUSMARCtoMySQL, StdCtrls, Buttons, ExtCtrls, Menus, Gauges;

type
  TfmIRBIStoMySQL = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    miFile: TMenuItem;
    miHelp: TMenuItem;
    gbxFiles: TGroupBox;
    lbedRUSMARCFileName: TLabeledEdit;
    lbedMySQLFileName: TLabeledEdit;
    bbOpenRUSMARCFile: TBitBtn;
    bbSaveMySQLFile: TBitBtn;
    gbxData: TGroupBox;
    lbedDatabaseName: TLabeledEdit;
    lbedTableName: TLabeledEdit;
    bbStart: TBitBtn;
    ggProcess: TGauge;
    bbStop: TBitBtn;
    miExit: TMenuItem;
    procedure bbOpenRUSMARCFileClick(Sender: TObject);
    procedure bbSaveMySQLFileClick(Sender: TObject);

    Function Process(Progress, MaxValue:Integer):Integer;
    procedure bbStartClick(Sender: TObject);
    procedure bbStopClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmIRBIStoMySQL: TfmIRBIStoMySQL;

implementation


{$R *.dfm}

Function TfmIRBIStoMySQL.Process(Progress, MaxValue:Integer):Integer;
Begin
  ggProcess.MinValue:=0;
  ggProcess.MaxValue:=MaxValue;
  ggProcess.Progress:=Progress;
  Application.ProcessMessages;
  Result:=0;
  If bbStop.Tag<>0 Then Result:=1;
End;

procedure TfmIRBIStoMySQL.bbOpenRUSMARCFileClick(Sender: TObject);
begin
  If Not(OpenDialog1.Execute) Then Exit;
  lbedRUSMARCFileName.Text:=OpenDialog1.FileName;
end;

procedure TfmIRBIStoMySQL.bbSaveMySQLFileClick(Sender: TObject);
begin
  If Not(SaveDialog1.Execute) Then Exit;
  lbedMySQLFileName.Text:=SaveDialog1.FileName;
end;

procedure TfmIRBIStoMySQL.bbStartClick(Sender: TObject);
Var
  Convertor:TDRUSMARCtoMySQL;
begin
  gbxFiles.Enabled:=False;
  gbxData.Enabled:=False;
  bbStart.Enabled:=False;
  bbStop.Enabled:=True;
  bbStop.Tag:=0;

  Convertor:=TDRUSMARCtoMySQL.Create;
  Convertor.RUSMARCFileName:=lbedRUSMARCFileName.Text;
  Convertor.MySQLFileName:=lbedMySQLFileName.Text;
  Convertor.DatabaseName:=lbedDatabaseName.Text;
  Convertor.TableName:=lbedTableName.Text;
  Convertor.OnProcess:=Process;

  If Convertor.Convert>=0 Then
    Application.MessageBox('  ', '', MB_ICONINFORMATION+MB_OK)
  Else
    Application.MessageBox('   ', '', MB_ICONERROR+MB_OK);

  Convertor.Free;

  gbxFiles.Enabled:=True;
  gbxData.Enabled:=True;
  bbStart.Enabled:=True;
  bbStop.Enabled:=False;
end;

procedure TfmIRBIStoMySQL.bbStopClick(Sender: TObject);
begin
  bbStop.Tag:=1;
end;

procedure TfmIRBIStoMySQL.miExitClick(Sender: TObject);
begin
  Close;
end;

end.
